﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ClientServer.Attributes;
using ClientServer.Db;
using ClientServer.Helpers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace ClientServer.Controllers.Core
{
    [Route(Constants.ApiPrefix + "time")]
    public class TimeController : ControllerWithDb
    {
        public TimeController(SyndromDbContext context) : base(context)
        {
        }

        /// <summary>
        /// returns the utc time of the server
        /// </summary>
        [HttpGet]
        [IsPublicApi]
        public Task GetUTCTime()
        {
            var now = DateTimeHelper.GetUtcNow();

            return
                Response.WriteAsync(
                    Jc.Serialize(new BasicResponseWithData<DateTime>(ResponseCode.Ok, "", now)));
        }
    }
}
