﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class CustomUserFiles : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "FileReferenceUserFileAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Hash = table.Column<string>(maxLength: 500, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 500, nullable: true),
                    OriginalName = table.Column<string>(maxLength: 500, nullable: true),
                    RelativePath = table.Column<string>(maxLength: 5000, nullable: true),
                    SizeInBytes = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_FileReferenceUserFileAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectDescriptionWithFileAsAssetReferences",
                columns: table => new
                {
                    CustomProjectDescriptionId = table.Column<int>(nullable: false),
                    FileReferenceUserFileAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectDescriptionWithFileAsAssetReferences", x => new { x.CustomProjectDescriptionId, x.FileReferenceUserFileAssetId });
                    table.ForeignKey(
                        name: "FK_CustomProjectDescriptionWithFileAsAssetReferences_CustomProjectDescriptions_CustomProjectDescriptionId",
                        column: x => x.CustomProjectDescriptionId,
                        principalTable: "CustomProjectDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectDescriptionWithFileAsAssetReferences_FileReferenceUserFileAssets_FileReferenceUserFileAssetId",
                        column: x => x.FileReferenceUserFileAssetId,
                        principalTable: "FileReferenceUserFileAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTestWithFileAsAssetReferences",
                columns: table => new
                {
                    CustomProjectTestId = table.Column<int>(nullable: false),
                    FileReferenceUserFileAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestWithFileAsAssetReferences", x => new { x.CustomProjectTestId, x.FileReferenceUserFileAssetId });
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithFileAsAssetReferences_CustomProjectTests_CustomProjectTestId",
                        column: x => x.CustomProjectTestId,
                        principalTable: "CustomProjectTests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithFileAsAssetReferences_FileReferenceUserFileAssets_FileReferenceUserFileAssetId",
                        column: x => x.FileReferenceUserFileAssetId,
                        principalTable: "FileReferenceUserFileAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithFileAsAssetReferences",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    FileReferenceUserFileAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithFileAsAssetReferences", x => new { x.CustomTestId, x.FileReferenceUserFileAssetId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithFileAsAssetReferences_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithFileAsAssetReferences_FileReferenceUserFileAssets_FileReferenceUserFileAssetId",
                        column: x => x.FileReferenceUserFileAssetId,
                        principalTable: "FileReferenceUserFileAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectDescriptionWithFileAsAssetReferences_CustomProjectDescriptionId",
                table: "CustomProjectDescriptionWithFileAsAssetReferences",
                column: "CustomProjectDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectDescriptionWithFileAsAssetReferences_FileReferenceUserFileAssetId",
                table: "CustomProjectDescriptionWithFileAsAssetReferences",
                column: "FileReferenceUserFileAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithFileAsAssetReferences_CustomProjectTestId",
                table: "CustomProjectTestWithFileAsAssetReferences",
                column: "CustomProjectTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithFileAsAssetReferences_FileReferenceUserFileAssetId",
                table: "CustomProjectTestWithFileAsAssetReferences",
                column: "FileReferenceUserFileAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithFileAsAssetReferences_CustomTestId",
                table: "CustomTestWithFileAsAssetReferences",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithFileAsAssetReferences_FileReferenceUserFileAssetId",
                table: "CustomTestWithFileAsAssetReferences",
                column: "FileReferenceUserFileAssetId");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "CustomProjectDescriptionWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "CustomProjectTestWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "CustomTestWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "FileReferenceUserFileAssets");
        }
    }
}
