﻿using System.ComponentModel.DataAnnotations;
using ClientServer.Db;
using ClientServer.Models.Interfaces;

namespace ClientServer.Models.CustomProjects
{
    /// <summary>
    /// an asset (file) for a test
    /// </summary>
    public class CustomProjectTestAsset : ITestAsset
    {
        public int Id { get; set; }
        /// <summary>
        /// the name of the file/asset
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string DisplayName { get; set; }
        /// <summary>
        /// the content of the asset (binary)
        /// </summary>
        public byte[] Content { get; set; }
        /// <summary>
        /// the mime type (maybe we need to know what content is stored)
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string MimeType { get; set; }
        
        /// <summary>
        /// the hash of the content
        /// can be null if not calculated but should not be null
        /// </summary>
        [MaxLength(SyndromDbContext.DefaultMaxStringLength)]
        public string Hash { get; set; }
    }
}
